* RTS3.for uses the same COPT math as RTS.for except the VER MW are in the generator file, input formats are different, and a target LOLE is added.
* Updated 11/26/2017  (no storage and integer gens)                      ! This program is identical to RTS3.m in Matlab format.
      CHARACTER C220*220,D220*220,F1*32,F2*32                            ! C is the current data and D is the previous C, F1 = generator data, F2 = hourly data
      REAL F(0:90000)/90001*0./,SF(20),VR(20),PCTC(20),VRES(20)          ! F is the capacity outage probability table COPT  PCTC=%capacity credit  VRES=VR energy by source on NSH days
      REAL LFU(7,2)/.006,.061,.242,.382,.242,.061,.006,7*0./             ! load forecast uncertainty probabilities and per unit load adjustments
      REAL*8 LOLP,LOLE1/0.D0/,LOLE2,LOLEV,LOLH,EUE,ENGT,VRE,VREC,        ! loss of load probability and expectation and loss of load hours are in double precision, total and variable resource energy
     & D(19),DSF,LOLE0,TLOLE/0.D0/,LOLP24(24),                           ! D( ) dummy variables  LOLE0 = old LOLE   LOLE1 is AM hours 1-12   LOLE2 is PM hours 13-24
     & DSFU,DSFL,HD,HD1,HD2                                              ! LOLP24 used to write to file 7  DSFU=demand scale factor upper limit  DSFL=demand scale factor lower limit
      INTEGER IH1/0/,IH2/0/,JS/0/,MW(24,24),IP/0/                        ! dummy hours used in LOLE AM PM tests, this line prevents a run time error  MW is for file 6 output  IP=0 do not print
      OPEN(5,FILE='OP.TXT')                                              ! open text output report file
      OPEN(6,FILE='OP.CSV')                                              ! open excel output report file
      OPEN(7,FILE='OPH.CSV')                                             ! we will write the houly LOLP's of significant days to this file
      WRITE(*,'(25HGENERATOR DATA FILE NAME:)')                          ! may I suggest you start with GDATA.txt
      READ(*,'(A32)') F1                                                 ! read generator file name, must be no longer than 32 characters
      WRITE(*,'(24HTARGET LOLE (OR RETURN):)')
      F2=' '
      READ(*,'(A32)') F2
      IF(F2.NE.' ') READ(F2,*) TLOLE                                     ! target LOLE desired, the DSF (demand scale factor) is changed to converge to a desired LOLE
      IF(TLOLE.LE.0.) IP=1                                               ! there is no iterating to a solution so print all lines
      OPEN(3,FILE=F1,STATUS='OLD',ERR=16)                                ! open the generator data file
      READ(3,'(I3,A220)') NCG,C220                                       ! read the GDATA file title, note - any data beyond col 223 is skipped, NCG is number of cols to read in generator file
      READ(3,'(A32)') F2                                                 ! read the HDATA file name with a comma at end of name
      J=32
      IF(NCG.LT.J) J=NCG
      F2=F2(1:J)                                                         ! fortran requires this shortening
      WRITE(*,*) 'HOURLY DATA: ',F2
      WRITE(*,*) 'RTS3 is executing...'
      WRITE(5,'(/13H GDATA File: ,A32                                    ! print the generator input data file name
     &          /13H HDATA File: ,A32                                    ! print the hourly input data file name
     &          //1X,A220)') F1,F2,C220                                  ! print the file names and the generation file title
      WRITE(6,'( 13H GDATA File: ,A32                                    ! print the generator input data file name
     &          /13H HDATA File: ,A32                                    ! print the hourly input data file name
     &          //A220)') F1,F2,C220                                     ! print the file names and the generation file title
      WRITE(7,'( 13H GDATA File: ,A32                                    ! print the generator input data file name
     &          /13H HDATA File: ,A32                                    ! print the hourly input data file name
     &          //A220)') F1,F2,C220                                     ! print the file names and the generation file title
      OPEN(4,FILE=F2,STATUS='OLD',ERR=17)                                ! open the hourly load and variable resource file
      READ(4,'(I3,A220)') NCH,C220                                       ! read the hourly data part of the study title  NCH is number of cols to read in hourly file
      IF(NCH.GT.220) THEN
        WRITE(*,*) 'HOURLY FILE READS MORE THAN 220 COLUMNS)'
        STOP
      ENDIF
      WRITE(5,'(1X,A220)') C220                                          ! print the hourly data file title
      WRITE(6,'(A220)') C220                                             ! print the hourly data file title
      WRITE(7,'(A220)') C220                                             ! print the hourly data file title
      READ(3,'(A220)',END=9) C220                                        ! read the demand multiplier and LFU
      READ(C220(1:NCG),*,ERR=9) DSF,PLFU,SLOLP                           ! read the demand scale factor and the %LFU and the significant LOLP cutoff SLOLP
      READ(3,'(A220)') C220                                              ! read the number of VR
      READ(C220(1:NCG),*,END=9,ERR=9) NVS                                ! read the number of variable sources
      READ(3,'(A220)',END=9) C220                                        ! read the % capacity credit
      READ(C220(1:NCG),*,ERR=9) (PCTC(I),I=1,NVS)                        ! read the percent capacity credit for the reserve margin calculation
      READ(3,'(A220)',END=9) C220                                        ! read the scale factors for the VR
      READ(C220(1:NCG),*,ERR=9) (SF(I),I=1,NVS)                          ! read the scale factors for the variable resources
      DO 12 I=1,7                                                        ! LFU has 7 steps (load forecast uncertainty per Billington 1986)
  12  LFU(I,2)=(I-4)*PLFU/100.                                           ! create the delta loads for the 7 step table for a normal distribution
      READ(3,'(A220)') C220                                              ! skip this header for generators
* calculate the COPT, the capacity outage probability table F
      WRITE(*,*) 'calculating the COPT'
      PMAX=0.                                                            ! Pmax is the sum of installed generation capacity (real numbers)
      MXF=0                                                              ! we store the maximum size of F that is needed for F(x)>1.E-16
      RMGEN=0.                                                           ! reserve margin generation used in the percent reserve calculation
      DO 1 I=1,99999
      READ(3,'(A220)',END=10) C220                                       ! read the generator data to the end of the file
      READ(C220(1:NCG),*,ERR=9) CAPA,RM,FOR,DFOR,DERA                    ! read bus#, genname, gentype, gen max MW, reserve margin %, forced outage rate, derated outage rate, MW derating
      RMGEN=RMGEN+CAPA*RM/100.                                           ! rerate generator's capacities for the reserve margin calculation
      PMAX=PMAX+CAPA                                                     ! PMAX is the total installed generation MW
      MAXGEN=PMAX                                                        ! MAXGEN is the next smallest integer of total PMAX installed generation MW
      MG=MAXGEN                                                          ! we can start sweeping across F where F is going to be >0.
      IF(MG.GT.90000) MG=90000                                           ! its ok for the MAXGEN to exceed 90000
      JP=CAPA                                                            ! this is the integer value of CAPA
      P=CAPA-JP                                                          ! P holds the decimal value of CAPA
      ID=DERA
      DP=DERA-ID                                                         ! DP holds the decimal value of DERA
      DO 1 IX=MG,0,-1                                                    ! sweep from right to left across F to convolve the next generator
      J=IX-JP                                                            ! J will point to the shifted to the right generator outage state
      FJ=1.-P                                                            ! all F(ix<0) = 1
      FP=P
      IF(J.GE.0)    FJ=F(J)*(1.-P)                                       ! ix is => 0  if P=0 this is the original equation
      IF(J-1.GE.0)  FP=F(J-1)*P                                          ! we are splitting up the F curve into two pieces separated by 1 MW
      JD=IX-ID                                                           ! JD will point to the shifted to the right generator MW derating state
      FD=1.-DP                                                           ! all F(jx<0) = 1
      FDP=DP
      IF(JD.GE.0)   FD=F(JD)*(1.-DP)                                     ! jx is => 0   if D = 0 we have the original integer capacity problem
      IF(JD-1.GE.0) FDP=F(JD-1)*DP
      F(IX)=(1.-FOR-DFOR)*F(IX) + DFOR*(FD+FDP) + FOR*(FJ+FP)            ! down states are shifted to the right and added to the up state which was not moved
      IF(F(IX).LT.1.E-37) F(IX)=0.                                       ! this prevents an underflow error message
      IF(F(IX).GE.1.E-16.AND.MXF.LT.IX) MXF=IX                           ! capture the largest IX needed, ignore smaller F
   1  CONTINUE
  10  WRITE(5,'(/12H MAX GENR  =,I11, 3H MW)') MAXGEN                    ! MAXGEN is the installed generation capacity
      CLOSE(3)
      DSFU=MAXGEN                                                        ! set the upper demand to the generation available
      IF(DSF.GT.DSFU) DSFU=DSF                                           ! if demand happens to be greater than the conventional generation supply
      DSFL=0.                                                            ! set the lower demand to zero
* read the hourly data file
      DO 15 ITER=1,30                                                    ! if it can't find the correct demand in 20 attempts then stop
      LOLE0=LOLE1
      IF(ITER.EQ.30) IP=1                                                ! print out something even if not converged
      REWIND(4)
      DO 14 I=1,14
  14  D(I)=0.                                                            ! zero out all the dummy variables starting a new study
      READ(4,'(I3,A220)') NCH,C220                                       ! read HDATA title again
      READ(4,'(A220)',END=9) C220
      IF(C220(1:10).NE.'YYYYMMDDHH')
     &  WRITE(5,'(23HYYYYMMDDHH out of place)')                          ! just a check to make sure were are reading the data in the correct order
      IF(ITER.EQ.1) THEN
        WRITE(7,'(/11X,14HYear,MoDaHr D,8X,14HLOLP,  NETDEM,A206)')      ! new YYYYMMDDHH line header for OPH report
     &    C220(14:220)
      ENDIF
      VRC=0.                                                             ! VRC will save the variable resource capacity MW credit
      DO 11 I=1,NVS
      VRES(I)=0.                                                         ! zero out the variable resource energy sum by source on significant days NSH
  11  VRC=VRC+SF(I)*PCTC(I)/100.                                         ! MW variable resource capacity, we don't add uncertainty here since the actual data already contains the uncertainty
      IF(ITER.EQ.1) THEN
        WRITE(5,'(12H VARBL RES =,I11, 3H MW)') INT(VRC+.5)              ! variable resource total MW capacity credit
        WRITE(5,'(12H GENR+VRES =,I11, 3H MW)') MAXGEN+INT(VRC+.5)       ! the sum of the GENR and VR capacities
        WRITE(5,'(12H MAX COPT  =,I11,12H (90000 MAX))') MXF             ! shows how much of F(x) array space was needed in this problem, COPT = capacity outage probability table
      ENDIF
      READ(4,'(A220)',END=9) C220                                        ! read the first line of hourly data
      D220=C220                                                          ! copy the first line of data to D220
      READ(C220,'(I4)') IFY                                              ! first year in HDATA
* repeat years as many times as there is annual data
      IYR=IFY-1
      NTH=0                                                              ! number of total hours
      DO 7 IY=1,9999                                                     ! simulate up to 9999 years of historical data
      IYR=IYR+1
      NSH=0                                                              ! number of significant hours, where LOLP>SLOLP significant LOLP
      LOLE1=0.D0              ! these indices will be created            ! this is the annual sum of LOLP peaks occurring in the AM hours 1-12
      LOLE2=0.D0              ! and summed in 7 LFU steps                ! this is the annual sum of LOLP peaks occurring in the PM hours 13-24
      LOLEV=0.D0                                                         ! loss of load events per year
      LOLH=0.D0                                                          ! loss of load hours is the sum of every hour's LOLP for a year
      EUE =0.D0                                                          ! EUE (or EENS) is the expected unserved energy of expected energy not served
      ENGT=0.D0                                                          ! this is the total energy served used in calculating the % unserved energy
      VRE =0.D0                                                          ! annual variable resource energy
      VREC=0.D0                                                          ! annual variable resource energy load, dumped, or curtailed
* sweep through all the hours calculating the LOLP each hour and the LOLE and LOLH
      IHRS=0                                                             ! count the hours per day and reset to define a new day, capture the max LOLP
      IH2OLD=0
      PLOLP1=0.               ! the lolps will be calculated for         ! PLOLP1 will be the peak AM period LOLP of each day if the AM has a peak
      PLOLP2=0.               ! each of the 7 steps and summed           ! PLOLP2 will be the peak PM period LOLP of each day if the PM has a peak
      PKDEM=0.                ! so only the lolp is affected by          ! capture the peak demand before renewables are applied
      PKNET=0.                ! the LFU                                  ! capture the peak net demand after renewables are applied
      IH3=0                   ! the hour during the day, we do this separately here because the YYYYMMDDHH can contain leap days with a screwed up hour
      IOK=0                   ! IOK=1 means list this day in file 6
      DO 4 IH=1,9999                                                     ! assume more hours than actual and note change in YY as start of a new year
      NTH=NTH+1                                                          ! total number of hours
      NH=IH
      READ(C220(14:NCH),*,ERR=9) DEMD,(VR(I),I=1,NVS)                    ! read the hourly demand and variable sources, YYYYMMDDHH and D are just for our reference
      HD=DEMD*DSF                                                        ! hourly MW demand is the first number read, the rest are variable sources
      I=HD
      IF(HD-I.LE..001) HD=I                                              ! for demand very close to an integer, round down to the integer
      IH3=IH3+1
      READ(C220(1:12),*) MW(23,IH3),MW(24,IH3)                           ! capture the YYYYMMDDHH in 23, D in 24, 22 net demand, 21 demand, VR in 1-20
      MW(21,IH3)=HD+.5                                                   ! capture the MW demand for hour IH3
      IF(HD.GT.PKDEM) PKDEM=HD                                           ! capture the peak demand for this year before renewables are applied
      HD1=HD                  ! the 7 step LFU will be applied to HD1    ! remember the native demand for this hour
      ENGT=ENGT+HD            ! only in the LOLP lookup in F(x)          ! this is the total energy of the original hourly demand
      IF(NVS.GT.0) THEN       ! and not applied to other values          ! see if any variable sources are present
        DO 2 I=1,NVS          ! everywhere the LOLP is used, the         ! if there are varible sources then loop through all of them
        HD=HD-VR(I)*SF(I)     ! the LFU will be carried forward          ! subtract the scaled variable source from the scaled hourly demand
   2    MW(I,IH3)=VR(I)*SF(I)+.5                                         ! capture the MW values of the VR this hour
      ENDIF
      IF(HD.GT.0.) THEN
        MW(22,IH3)=HD+.5
      ELSE
        MW(22,IH3)=HD-.5
      ENDIF
      IF(HD.LT.0.) THEN
        VREC=VREC-HD                                                     ! remember the total renewable energy that has been dumped
        HD=0.                                                            ! however, if the net hourly demand is negative, then set the demand to 0 MW
      ENDIF
      IF(HD.GT.PKNET) PKNET=HD                                           ! capture the net peak demand for this year after renewables are applied
      VRE=VRE+(HD1-HD)                                                   ! sum up the total variable source energy that has been applied to the demand
      LOLP=0.D0                                                          ! getting ready to sum the LOLPs for the 7 LFU steps
      DO 13 L=1,7                                                        ! now we loop through all the LFU steps
      HD2=HD+HD1*LFU(L,2)                                                ! HD2 is a new modified demand that contains the load undertainty
      IF(HD2.LT.0.) HD2=0.                                               ! let's just avoid feeding negative load to the COPT, the LOLP is zero anyway
      IHD=HD2                                                            ! this is the integer part of HD2 to the left of the decimal
      P=HD2-IHD                                                          ! P is the fraction of MW < 1 MW greater than the integer HD MW
      IF(MAXGEN-IHD.LE.MXF) THEN                                         ! assume F(X>MXF)=0  MAXGEN minus integer part of the demand on the COPT
        D(15)=0.D0                                                       ! sum up the unserved energy for this hour, D(15) is just a dummy variable
        DO 3 I=MXF,MAXGEN-IHD,-1                                         ! this loop is to sum up the unserved energy under the COPT
        FI=1.
        IF(I.GE.0) FI=F(I)
   3    D(15)=D(15)+FI                                                   ! 1 MW wide increments of load with F probability not served starting with the smallest of F
        IF(P.GT.0.) THEN                                                 ! this is the small fraction of load < 1 MW but greater than the IHD integer MW load
          IHD=IHD+1                                                      ! pick up the LOLP for the next higher MW load level, its a stairstep
          FI=1.
          IF(MAXGEN-IHD.GE.0) FI=F(MAXGEN-IHD)
          D(15)=D(15)+P*FI                                               ! and add on that bit of unserved energy
        ENDIF
        EUE=EUE+D(15)*LFU(L,1)                                           ! add on this hour's unserved energy D(15) to the running sum EUE
        FI=1.
        IF(MAXGEN-IHD.GE.0) FI=F(MAXGEN-IHD)
        LOLP=LOLP+FI*LFU(L,1)                                            ! the LOLP is a lookup for the higher demand if P>0, this line works also for P=0
      ENDIF
  13  CONTINUE                                                           ! end of the LFU and LOLP calculations
      IF(LOLP.GE.SLOLP) THEN
        NSH=NSH+1                                                        ! a significant hour LOLP=>significant LOLP
        IOK=1                                                            ! OK remember this day is sgnificant for printing to OPH.CSV
        DO 22 I=1,NVS
  22    VRES(I)=VRES(I)+VR(I)*SF(I)                                      ! sum the MW of VR for significant hours so we can average the MW of each VR during these hours
      ENDIF
      LOLP24(IH3)=LOLP
      IF(IOK.EQ.1.AND.(IH3.EQ.24.OR.C220(9:10).EQ.'24')) THEN
        DO 21 I=1,24
        WRITE(F1,'(I10)') MW(23,I)
        IF(IP.EQ.1) WRITE(7,'(A4,2H, A6,I4,1H,F8.6,1H,21(I9,1H,))')
     &    F1(1:4),F1(5:10),MW(24,I),LOLP24(I),MW(22,I),MW(21,I),
     &    (MW(J,I),J=1,NVS)
  21    CONTINUE
      ENDIF
      IF(IH3.EQ.24.OR.C220(9:10).EQ.'24') THEN
        IOK=0
        IH3=0
      ENDIF
      LOLH=LOLH+LOLP                                                     ! calculate the annual loss of load hours
      IHRS=IHRS+1                                                        ! this is the hour of the day
      IF(IHRS.LE.12) THEN                                                ! the AM period
        IF(LOLP.GT.PLOLP1) THEN
          PLOLP1=LOLP                                                    ! capture the max LOLP1 each day
          IH1=IHRS                                                       ! remember the hour of the peak AM LOLP
        ENDIF
      ELSE                                                               ! the else will be hours 13-24
        IF(LOLP.GT.PLOLP2) THEN
          PLOLP2=LOLP                                                    ! capture the max LOLP2 each day
          IH2=IHRS                                                       ! remember the hour of the peak PM LOLP
        ENDIF
      ENDIF
      IF(IHRS.EQ.24) THEN                                                ! we are at the end of a day
* see if the AM and PM peak LOLPs are separated by at least 6 hours
        IF(IH2-IH1.LE.6.OR.24-IH2OLD+IH1.LE.6) THEN                      ! peak LOLPs are too close together to treat as separate events
          IF(PLOLP2.GE.PLOLP1) PLOLP1=0.
          IF(PLOLP1.GE.PLOLP2) THEN
            IH2=15                                                       ! make sure its not close to midnight is all
            PLOLP2=0.
          ENDIF
        ENDIF
        LOLEV=LOLEV+PLOLP1+PLOLP2                                        ! loss of load events can count up to two events per day if they meet the above tests
        IF(PLOLP2.GE.PLOLP1) PLOLP1=0.                                   ! this goes ahead and resets the AM and PM max LOLPs so there is only one per day
        IF(PLOLP1.GE.PLOLP2) PLOLP2=0.
        LOLE1=LOLE1+PLOLP1                                               ! the LOLE1 is the sum of daily maximum AM LOLPs
        LOLE2=LOLE2+PLOLP2                                               ! the LOLE2 is the sum of daily maximum PM LOLPs
        PLOLP1=0.                                                        ! reset PLOLP1 for a new day
        PLOLP2=0.                                                        ! reset PLOLP2 for a new day
        IHRS=0                                                           ! reset the hours counter for a new day
        IH2OLD=IH2                                                       ! this it the hour of max LOLP in the PM of the previous day
      ENDIF
      C220=' '
      READ(4,'(A220)',END=5) C220                                        ! read a new line of data or exit to the final report
      IF(C220(1:4).NE.D220(1:4)) GOTO 5                                  ! we must have started a new year if the YY is different, go to the report
      D220=C220                                                          ! copy the line of data to D220 for this hour
   4  CONTINUE                                                           ! end of the hour loop, do the next hour, which we never reach the end of this loop
   5  NY=IY                                                              ! remember the number of years
      IF(IP.EQ.1) THEN
        WRITE(5,'(/I5,9H RESULTS:)') IYR
        WRITE(5,'(12H PERIOD    =,I11,6H HOURS)') NH
        WRITE(5,'(12H PEAK DEMD =,F11.3,3H MW)') PKDEM
        RM=(RMGEN+VRC)/PKDEM*100.-100.                                   ! reserve margin calculation
        WRITE(5,'(12H RESERVE   =,F11.1,2H %)') RM
        WRITE(5,'(12H LOAD ENGY =,F11.0,4H GWh)') ENGT/1000.
        WRITE(5,'(12H LOAD FACT =,F11.3,2H %)') 100.*ENGT/(NH*PKDEM)
        WRITE(5,'(12H PEAK NETD =,F11.3,13H MW (DEMD-VR))') PKNET
        WRITE(5,'(12H VR E USED =,F11.0,4H GWh)') VRE/1000.
        WRITE(5,'(12H VR E LOST =,F11.0,4H GWh)') VREC/1000.
        WRITE(5,'(14H Indices for a,F6.2,6H% LFU:)') PLFU
        WRITE(5,'(12H LOLE(AM)  =,F11.6,4H d/y)') LOLE1                  ! the AM LOLE
        WRITE(5,'(12H LOLE(PM)  =,F11.6,4H d/y)') LOLE2                  ! the PM LOLE
        WRITE(5,'(12H LOLE      =,F11.6,4H d/y)') LOLE1+LOLE2            ! LOLE = 1.368863 which agrees exactly with the 1986 paper.
        WRITE(5,'(12H LOLEV **  =,F11.6,9H events/y)') LOLEV             ! loss of load events
        WRITE(5,'(12H LOLEMW    =,F11.0,3H MW)') EUE/LOLH                ! the expected MW for loss of load
        WRITE(5,'(12H LOLH      =,F11.6,4H h/y)') LOLH                   ! LOLH =   9.394175 which agrees exactly with the 1986 paper.
        WRITE(5,'(12H LOLH/event=,F11.6,8H h/event)') LOLH/LOLEV         ! duration of loss of load in hours per event
        WRITE(5,'(12H EUE MWh   =,F11.0,4H MWh)') EUE
        WRITE(5,'(12H EUE ppm   =,F11.2,7H pu ppm)') EUE/ENGT*1.E6
        WRITE(5,'(12H EUE %     =,F11.6,2H %)') EUE/ENGT*100.            ! % unserved energy, .007690 is consistent with EUE of 1.176 in the 1986 paper
        WRITE(5,'(6H LOLP>,1PE5.0E1,1H=,I11  ,4H hrs)') SLOLP,NSH        ! significant LOLP and number of hours with significant LOLPs
      ENDIF
      D(1)=D(1)+PKDEM
      D(2)=D(2)+ENGT/1000.
      D(3)=D(3)+100.*ENGT/(NH*PKDEM)
      D(4)=D(4)+PKNET
      D(5)=D(5)+VRE/1000.
      D(6)=D(6)+VREC/1000.
      D(7)=D(7)+LOLE1
      D(8)=D(8)+LOLE2
      D(9)=D(9)+LOLEV
      D(10)=D(10)+LOLH
      D(11)=D(11)+EUE
      D(12)=D(12)+ENGT
      D(13)=D(13)+NSH                                                    ! total number of significant hours for the entire period
      D(14)=D(14)+RM                                                     ! reserve margin calculation
      IF(C220(1:3).EQ.'end') GOTO 8                                      ! we reached the end of the datain file
      D220=C220                                                          ! remember C220 for the new year set of data
   7  CONTINUE
   8  LOLE1=(D(7)+D(8))/NY
      IF(LOLE1.GT.TLOLE.AND.DSF.LT.DSFU) DSFU=DSF                        ! reduce the upper demand limit
      IF(LOLE1.LT.TLOLE.AND.DSF.GT.DSFL) DSFL=DSF                        ! increase the lower demand limit
      IF(NY.GT.1.AND.IP.EQ.1) THEN
        WRITE(5,'(/16H AVERAGE VALUES:)')
        WRITE(5,'(12H PERIOD    =,I11,6H HOURS)') NTH/NY
        WRITE(5,'(12H PEAK DEMD =,F11.3,3H MW)')  D(1)/NY
        WRITE(5,'(12H RESERVE   =,F11.1,2H %)') D(14)/NY
        WRITE(5,'(12H LOAD ENGY =,F11.0,4H GWh)') D(2)/NY
        WRITE(5,'(12H LOAD FACT =,F11.3,2H %)')   D(3)/NY
        WRITE(5,'(12H PEAK NETD =,F11.3,13H MW (DEMD-VR))') D(4)/NY
        WRITE(5,'(12H VR E USED =,F11.0,4H GWh)') D(5)/NY
        WRITE(5,'(12H VR E LOST =,F11.0,4H GWh)') D(6)/NY
        WRITE(5,'(14H Indices for a,F6.2,6H% LFU:)') PLFU
        WRITE(5,'(12H LOLE(AM)  =,F11.6,4H d/y)') D(7)/NY
        WRITE(5,'(12H LOLE(PM)  =,F11.6,4H d/y)') D(8)/NY
        WRITE(5,'(12H LOLE      =,F11.6,4H d/y)') LOLE1
        WRITE(5,'(12H LOLEV **  =,F11.6,9H events/y)') D(9)/NY
        WRITE(5,'(12H LOLEMW    =,F11.0,3H MW)')  D(11)/D(10)
        WRITE(5,'(12H LOLH      =,F11.6,4H h/y)') D(10)/NY
        WRITE(5,'(12H LOLH/event=,F11.6,8H h/event)') D(10)/D(9)
        WRITE(5,'(12H EUE MWh   =,F11.0,4H MWh)') D(11)/NY
        WRITE(5,'(12H EUE ppm   =,F11.2,7H pu ppm)') D(11)/D(12)*1.E6
        WRITE(5,'(12H EUE %     =,F11.6,2H %)')   D(11)/D(12)*100.
        WRITE(5,'(6H LOLP>,1PE5.0E1,1H=,I11  ,8H avg hrs)')
     &    SLOLP,INT(D(13)/NY+.5)                                         ! significant LOLP and total study period hours with significant LOLPs
      ENDIF
      IF(JS.EQ.0.AND.TLOLE.GT.0.) THEN
        WRITE(*,'(46H LOLE d/y  MW Demand     Upper MW     Lower MW)')
        JS=1
      ENDIF
      IF(IP.EQ.1.AND.NVS.GT.0.AND.D(13).GT.0.) THEN
        WRITE(5,*) ' '
        WRITE(5,*)   'Variable Resource Capacity Credits'
        WRITE(5,'(29H Max Net Demand hrs for LOLP>,1PE5.0E1,1H:)') SLOLP
        WRITE(5,'(/20(F6.1,1H%))') (100.*VRES(I)/D(13)/SF(I),I=1,NVS)
      ENDIF
      IF(TLOLE.GT.0.) WRITE(*,'(F9.6,2X,3G13.7)') LOLE1,DSF,DSFU,DSFL
      IF(IP.EQ.1) GOTO 20                                                ! skip iterative target LOLE or we are ready to wrap it up
      IF(ABS(TLOLE-LOLE1).LE..0001*TLOLE.OR.DSFU-DSFL.LT..01) THEN       ! the iteration is solved
        IF(LOLE1.GE.TLOLE) THEN
          IP=1
          GOTO 15
        ENDIF
      ENDIF
      IF(TLOLE.GT.LOLE1.AND.DSF.GT.DSFL) DSFL=DSF                        ! lower the upper bound to the latest tested DSF
      IF(TLOLE.LT.LOLE1.AND.DSF.LT.DSFU) DSFU=DSF                        ! raise the lower bound to the latest tested DSF
      DSF=(DSFU+DSFL)/2.                                                 ! DSF is the average of high and low DSF bounds
  15  CONTINUE
  20  WRITE(*,*)' '
      WRITE(5,*)' '
      WRITE(5,*)'** LOLE  measures events/24 hrs'
      WRITE(5,*)'   LOLEV measures events/12 hrs'
      CLOSE(5)
      OPEN(5,FILE='OP.TXT')                                              ! open text output report file so we can read the numbers and write them to OP.csv
      WRITE(6,'(/A192,1PE5.0E1,4H hrs)') '          YEAR,  PKDEMD,     %
     &RESV,LoadGWh,%LDFact,PKnetMW,    VRGWh,      VRlost,        %LFU,L
     &OLE(AM),LOLE(PM),LOLE(d/y),LOLEV(#/y),LOLEMW,LOLH(h/y),LOLH(h/e),E
     &UEMWh,   EUEppm,    EUE%,LOLP>',SLOLP
      READ(5,'(//////////1X,A4)') F1
  18  READ(5,'(/1X,A4/7(/12X,F11.0)/14X,F6.0,11(/12X,F11.0))',ERR=19)
     & F1,D
      WRITE(6,'(A4,1H,F11.3,1H,F11.1,1H,F11.0,1H,F11.3,1H,F11.3,1H,F11.0
     &,1H,F11.0,1H,F11.2,1H,F11.6,1H,F11.6,1H,F11.6,1H,F11.6,1H,F11.0,1H
     &,F11.6,1H,F11.6,1H,F11.0,1H,F11.2,1H,F11.6,1H,F11.0,1H,)') F1,D
      GOTO 18
  19  CLOSE(5)
      CLOSE(6)
      CLOSE(7)
      WRITE(*,*) 'SEE OP.TXT OP.CSV OPH.CSV FILES'
      WRITE(*,*) 'PRESS ENTER TO END THIS PROGRAM'
      READ(*,'(A1)') C220
      STOP
   9  WRITE(*,'(16H ERROR READING: ,A220)') C220
      WRITE(*,*) 'PRESS ENTER TO END THIS PROGRAM'
      READ(*,'(A1)') C220
      STOP
  16  WRITE(*,*) 'OPEN FILE ERROR: ',F1
      STOP
  17  WRITE(*,*) 'OPEN FILE ERROR: ',F2
      STOP
      END
